commit 3845a68155f89279f2d7433f8532601549932bf2
Author: l.suhrbier <l.suhrbier@localhost>
Date:   Tue Aug 23 08:59:22 2011 +0000

diff --git a/.gitattributes b/.gitattributes
index a6f396355..98324ade8 100644
--- a/.gitattributes
+++ b/.gitattributes
@@ -326,15 +326,6 @@ eu.etaxonomy.taxeditor.editor.rap/.classpath -text
 eu.etaxonomy.taxeditor.editor.rap/.project -text
 eu.etaxonomy.taxeditor.editor.rap/.settings/org.eclipse.jdt.core.prefs -text
 eu.etaxonomy.taxeditor.editor.rap/META-INF/MANIFEST.MF -text
-eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/key/polytomous/PolytomousKeyListLabelProviderFacadeImpl.class -text
-eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/name/container/EditorAnnotationFacadeImpl.class -text
-eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/name/container/LineBreakListenerFacadeImpl.class -text
-eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/name/container/LineWrapSupportFacadeImpl.class -text
-eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/name/container/NameViewerFacadeImpl.class -text
-eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/view/concept/ConceptLabelProviderFacadeImpl.class -text
-eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/view/descriptive/DescriptiveLabelProviderFacadeImpl.class -text
-eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/org/eclipse/jface/text/PositionFacadeImpl.class -text
-eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/org/eclipse/jface/window/ToolTipFacadeImpl.class -text
 eu.etaxonomy.taxeditor.editor.rap/build.properties -text
 eu.etaxonomy.taxeditor.editor.rap/src/eu/etaxonomy/taxeditor/singlesource/editor/key/polytomous/PolytomousKeyListLabelProviderFacadeImpl.java -text
 eu.etaxonomy.taxeditor.editor.rap/src/eu/etaxonomy/taxeditor/singlesource/editor/name/container/EditorAnnotationFacadeImpl.java -text
diff --git a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/key/polytomous/PolytomousKeyListLabelProviderFacadeImpl.class b/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/key/polytomous/PolytomousKeyListLabelProviderFacadeImpl.class
deleted file mode 100644
index 6266fe2c6..000000000
Binary files a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/key/polytomous/PolytomousKeyListLabelProviderFacadeImpl.class and /dev/null differ
diff --git a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/name/container/EditorAnnotationFacadeImpl.class b/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/name/container/EditorAnnotationFacadeImpl.class
deleted file mode 100644
index de9dc120a..000000000
Binary files a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/name/container/EditorAnnotationFacadeImpl.class and /dev/null differ
diff --git a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/name/container/LineBreakListenerFacadeImpl.class b/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/name/container/LineBreakListenerFacadeImpl.class
deleted file mode 100644
index 070f88cfa..000000000
Binary files a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/name/container/LineBreakListenerFacadeImpl.class and /dev/null differ
diff --git a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/name/container/LineWrapSupportFacadeImpl.class b/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/name/container/LineWrapSupportFacadeImpl.class
deleted file mode 100644
index 4562d43e5..000000000
Binary files a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/name/container/LineWrapSupportFacadeImpl.class and /dev/null differ
diff --git a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/name/container/NameViewerFacadeImpl.class b/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/name/container/NameViewerFacadeImpl.class
deleted file mode 100644
index 1d9acc5f1..000000000
Binary files a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/name/container/NameViewerFacadeImpl.class and /dev/null differ
diff --git a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/view/concept/ConceptLabelProviderFacadeImpl.class b/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/view/concept/ConceptLabelProviderFacadeImpl.class
deleted file mode 100644
index e880cd69a..000000000
Binary files a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/view/concept/ConceptLabelProviderFacadeImpl.class and /dev/null differ
diff --git a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/view/descriptive/DescriptiveLabelProviderFacadeImpl.class b/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/view/descriptive/DescriptiveLabelProviderFacadeImpl.class
deleted file mode 100644
index 61b76f4d8..000000000
Binary files a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/editor/view/descriptive/DescriptiveLabelProviderFacadeImpl.class and /dev/null differ
diff --git a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/org/eclipse/jface/text/PositionFacadeImpl.class b/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/org/eclipse/jface/text/PositionFacadeImpl.class
deleted file mode 100644
index b6f74e21d..000000000
Binary files a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/org/eclipse/jface/text/PositionFacadeImpl.class and /dev/null differ
diff --git a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/org/eclipse/jface/window/ToolTipFacadeImpl.class b/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/org/eclipse/jface/window/ToolTipFacadeImpl.class
deleted file mode 100644
index bfa92b570..000000000
Binary files a/eu.etaxonomy.taxeditor.editor.rap/bin/eu/etaxonomy/taxeditor/singlesource/org/eclipse/jface/window/ToolTipFacadeImpl.class and /dev/null differ